#include <stdio.h>

using namespace std;

int main(){
    int n, k;
    scanf("%d %d", &n, &k);
    int a[n];
    for (int i = 0; i < n; i++){
        scanf("%d", &a[i]);
    }
    bool b[n] = {false};
    int i = 0;
    int ss = 0;
    while (i < n-1 && k > 0){
        if (a[i] > a[i+1] && !b[i]){
            b[i] = true;
            k--;
            //printf("%d\n", ss);
            for(int j = ss+1; j < i; j++){
                //printf("%d %d %d", a[j], a[i+1], k);
                if (j > i) break;
                if (a[j] > a[i+1] && i - j <= k){
                    b[j] = true;
                    k--;
                }
            }
            ss = i;
        }
        else
            b[i] = false;
        i++;
    }
    for (i = 0; i < n; i++){
        if (!b[i]) printf("%d ", a[i]);
    }
    return 0;
}